#include "stdafx.h"
#include "WinBarf.h"
#include "WinBarfDlg.h"
#include <stdio.h>
#include <direct.h>  // _getcwd, _chdir, _mkdir
// #include <time.h> // ctime

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
 char THIS_FILE[] = __FILE__;
#endif

/* ----------------- */
/* --- Constants --- */
/* ----------------- */

// Default size of Buffer in Kb
#define DEFAULT_BUFFER_SIZE 4

// File flags
enum
{
    FLAG_NONE      = 0,
    FLAG_ENCRYPTED = (1 << 4)  // 0x10
};

// Boolean
#ifndef __cplusplus  // Standard C++ has already this "bool"
    typedef enum { false, true } bool;
#endif

// Command
typedef enum
{
    CMD_LIST,
    CMD_EXTRACT
} Command_t;

// RFF header
typedef struct
{
    unsigned char  Magic [4];
    unsigned int Version;
    unsigned int DirOffset;
    unsigned int DirNbEntries;
    unsigned int Unknown1;
    unsigned int Unknown2;
    unsigned int Unknown3;
    unsigned int Unknown4;
} RffHeader_t;

// Directory entry for a file
typedef struct
{
    unsigned char  Unknown0 [16];
    unsigned int Offset;
    unsigned int Size;
    unsigned int Unknown1;
    unsigned int Time;           // Obtained with the "time" standard function
    unsigned char  Flags;
    char   Name [11];
    unsigned int Unknown2;       // ID ? Maybe for an enumeration function...
} DirectoryEntry_t;

// Informations about a packed file
typedef struct
{
    char   Name [13];
    unsigned char  Flags;
    unsigned int Time;
    unsigned int Size;
    unsigned int Offset;
} FileInfos_t;


/* ------------------------ */
/* --- Global variables --- */
/* ------------------------ */

// The RFF file
 FILE* RffFile = NULL;
// char RffFileName [MAX_PATH];

// Number of files in the RFF file
 unsigned int NbFiles = 0;

// Array of informations about the packed files
 FileInfos_t* FileInfos = NULL;

// All purpose buffer (so we don't have to "malloc" one each time we need some storage)
 unsigned char* Buffer;
 unsigned int BufferSize = DEFAULT_BUFFER_SIZE * 1024;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinBarfDlg dialog

CWinBarfDlg::CWinBarfDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWinBarfDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWinBarfDlg)
	m_RffFileName = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWinBarfDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWinBarfDlg)
	DDX_Control(pDX, IDC_RFFLIST, m_RffDataBox);
	DDX_Control(pDX, IDC_LOG, m_LogBox);
	DDX_LBString(pDX, IDC_RFFLIST, m_RffFileName);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWinBarfDlg, CDialog)
	//{{AFX_MSG_MAP(CWinBarfDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOPEN, OnOpen)
	ON_LBN_SELCHANGE(IDC_RFFLIST, OnSelchangeRfflist)
	ON_COMMAND(AFX_IDS_OPENFILE, OnIdsOpenfile)
	ON_COMMAND(ID_HELP_ABOUTWINBARF, OnHelpAboutwinbarf)
	ON_COMMAND(ID_FILE_CLEARLOGBOX, OnFileClearlogbox)
	ON_COMMAND(ID_FILE_CLEARRFFDATABOX, OnFileClearrffdatabox)
	ON_COMMAND(ID_FILE_EXTRACTFILES, OnFileExtractfiles)
	ON_COMMAND(ID_FILE_EXTRACTALL, OnFileExtractall)
	ON_COMMAND(ID_MISC_CLEARRFFBOXSELECTIONS, OnMiscClearrffboxselections)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinBarfDlg message handlers

BOOL CWinBarfDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWinBarfDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWinBarfDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWinBarfDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CWinBarfDlg::OnOpen() 
{
	ExtractAllFiles = false;
	ExtractFiles = false;
	CFileDialog m_ldFile(TRUE); // create instance of file dialog window 
// a lotta code for a little tweak. shows JUST rff files, or all files. 
m_ldFile.m_ofn.lpstrFilter=TEXT("Blood Resource Files (*.RFF)\0*.RFF\0All Files (*.*)\0*.*\0"); 
	

if (m_ldFile.DoModal() == IDOK)	// this is what makes the popup happen!
{   

	// and we get that file name...	
	RffFileName = m_ldFile.GetFileName();		
	//now we clean out the box in case it had stuff in it. 
	m_RffDataBox.ResetContent();
	// update the log...
	m_LogBox.AddString(RffFileName + " was selected"); 
	
} // end if    
	if (!RffFileName.IsEmpty()) // this caused a crash on exit bug???
	oldmain(RffFileName.GetBuffer(4));

	// update the window with the data
	UpdateData(FALSE);			
}

/*
====================
ExtractFile

Extract files which match "MatchName"
====================
*/
bool CWinBarfDlg::ExtractFile (const char* MatchName)
{
   	Buffer = (unsigned char *) malloc (BufferSize);
    if (Buffer == NULL)
        {
            m_LogBox.AddString("Not enough memory to allocate the extraction buffer");//error
            fclose (RffFile);
            return EXIT_FAILURE;
        }
	// Variables
    unsigned int NbReadBytes;
    unsigned int NbRequestedBytes;
    unsigned int NbRemainBytes;
    unsigned int Ind;
    unsigned int FileInfosIndex;
    FILE* ExtractedFile;

    // Find the file index
    for (FileInfosIndex = 0; FileInfosIndex < NbFiles; FileInfosIndex++)
        if (stricmp (MatchName, FileInfos[FileInfosIndex].Name) == 0)
            break;
    if (FileInfosIndex == NbFiles)
    {
    	m_LogBox.AddString("Can't find file");
        return false;
    }
    	
    // Go to the start of the file
    if (fseek (RffFile, FileInfos[FileInfosIndex].Offset, SEEK_SET) != 0)
    {
        m_LogBox.AddString("Can't go to the offset"); // error
        return false;
    }

    // Extract the first part
    NbRemainBytes = FileInfos[FileInfosIndex].Size;
    NbRequestedBytes = (NbRemainBytes > BufferSize) ?  BufferSize : NbRemainBytes;
    NbReadBytes = fread (Buffer, 1, NbRequestedBytes, RffFile);
    if (NbReadBytes != NbRequestedBytes)
    {
        m_LogBox.AddString("Can't extract enough bytes from the RFF file"); //error
        return false;
    }
    NbRemainBytes -= NbReadBytes;

    unsigned short fileSize = strlen(FileInfos[FileInfosIndex].Name);
    char extension[4], buffer[_MAX_PATH], buffer2[_MAX_PATH];
    
    // Snag the extension why don't cha?
    extension [0] = FileInfos[FileInfosIndex].Name[fileSize-3];
    extension [1] = FileInfos[FileInfosIndex].Name[fileSize-2];
    extension [2] = FileInfos[FileInfosIndex].Name[fileSize-1];
    extension [3] = '\0';

    _mkdir(extension);                          // make the new directory
    _getcwd(buffer,_MAX_PATH);                  // grab the current directory
    sprintf(buffer2, "%s\\%s", buffer, extension);// smoosh them together 
    _chdir(buffer2);
    
    m_LogBox.AddString(buffer2);

    // Open the new file
    ExtractedFile = fopen (FileInfos[FileInfosIndex].Name, "wb");
    if (ExtractedFile == NULL)
    {
        m_LogBox.AddString("Can't create the new file"); //error
        return false;
    }

    // Decrypt the first bytes if they're encrypted (256 bytes max)
    if ((FileInfos[FileInfosIndex].Flags & FLAG_ENCRYPTED) != 0)
        for (Ind = 0; Ind < ((NbReadBytes > 256) ? 256 : NbReadBytes); Ind++)
            Buffer[Ind] ^= (Ind >> 1);

    // Copy its contents into the new file
    fwrite (Buffer, 1, NbReadBytes, ExtractedFile);

    // While there is bytes remaining in the file
    while (NbRemainBytes != 0)
    {
        // Load the next bytes
        NbRequestedBytes = (NbRemainBytes > BufferSize) ?  BufferSize : NbRemainBytes;
        NbReadBytes = fread (Buffer, 1, NbRequestedBytes, RffFile);
        if (NbReadBytes != NbRequestedBytes)
        {
            m_LogBox.AddString("Can't extract enough bytes from the RFF file"); //error
            fclose (ExtractedFile);
            return false;
        }
        NbRemainBytes -= NbReadBytes;

        // Copy its contents into the new file
        fwrite (Buffer, 1, NbReadBytes, ExtractedFile);
    }
	
	// a temporary file name to please the addstring dealie.	
	CString tempFileName = FileInfos[FileInfosIndex].Name;
	// add to the log what got extracted. 
	m_LogBox.AddString (tempFileName + " Was extracted."); 
	// close up 
    fclose (ExtractedFile);
    _chdir(buffer);
    // moved this so the memory would get freed AFTER the extract. 
	free (Buffer);
    return true;
}


/*
====================
LoadRffInformations

Load informations about the contents of the RFF file
====================
*/
bool CWinBarfDlg:: LoadRffInformations (void)
{
    // Variables
    unsigned char* Directory;
    unsigned int NbReadBytes;
    RffHeader_t RffHeader;
    DirectoryEntry_t* DirectoryEntry;
    unsigned int Ind; 
    char FileName [9] = "00000000";// tim, C++ style yo!  
    char FileExtension [4] = "000";// tim, C++ style yo!
    unsigned char CryptoByte;

    // Read the header
    NbReadBytes = fread (&RffHeader, 1, sizeof (RffHeader), RffFile);
    if (NbReadBytes != sizeof (RffHeader))
    {
        m_LogBox.AddString("RFF file is too short to be valid"); //error
        return false;
    }

    m_LogBox.AddString("Files found");
    NbFiles = RffHeader.DirNbEntries;

    // Read the directory
    fseek (RffFile, RffHeader.DirOffset, SEEK_SET);
    Directory = (unsigned char *) malloc (RffHeader.DirNbEntries * sizeof (DirectoryEntry_t));
    if (Directory == NULL)
    {
        m_LogBox.AddString("Not enough memory to load the directory");//error
        return false;
    }
    NbReadBytes = fread (Directory, 1, RffHeader.DirNbEntries * sizeof (DirectoryEntry_t), RffFile);
    if (NbReadBytes != RffHeader.DirNbEntries * sizeof (DirectoryEntry_t))
    {
        m_LogBox.AddString("Can't read the whole dictionary");//error
        free (Directory);
        return false;
    }

    // Decrypt the directory
    CryptoByte = (unsigned char)RffHeader.DirOffset;
    for (Ind = 0; Ind < RffHeader.DirNbEntries * sizeof (DirectoryEntry_t); Ind += 2)
    {
        Directory[Ind    ] ^= CryptoByte;
        Directory[Ind + 1] ^= CryptoByte;
        CryptoByte++;
    }

    // Allocate "FileInfos"
    FileInfos = (FileInfos_t *)malloc (RffHeader.DirNbEntries * sizeof (FileInfos_t));
    if (FileInfos == NULL)
    {
        m_LogBox.AddString("Not enough memory to store the directory");//error
        free (Directory);
        return false;
    }

    // Print the directory informations and store them in "FileInfos"
    DirectoryEntry = (DirectoryEntry_t*)Directory;
    for (Ind = 0; Ind < RffHeader.DirNbEntries; Ind++)
    {
        // Extract the file name
        strncpy (FileExtension, DirectoryEntry->Name,     3);
        strncpy (FileName,      &DirectoryEntry->Name[3], 8);
        // set up the FileInfos object data        
        sprintf (FileInfos[Ind].Name, "%s.%s", FileName, FileExtension);
        FileInfos[Ind].Offset = DirectoryEntry->Offset;
        FileInfos[Ind].Size   = DirectoryEntry->Size;
        FileInfos[Ind].Flags  = DirectoryEntry->Flags;
        FileInfos[Ind].Time   = DirectoryEntry->Time;
		// add entries to list box... if it's not already there!
		if (m_RffDataBox.FindString(-1,FileInfos[Ind].Name) == LB_ERR)
		m_RffDataBox.AddString(FileInfos[Ind].Name);
        
		DirectoryEntry++;
    }
    free (Directory);
//    extractFlag = false;
	return true;
}


/*
====================
main

Main procedure
====================
*/
int CWinBarfDlg::oldmain (char* RffFileName)
{
    RffFile = fopen (RffFileName, "rb");
    if (RffFile == NULL)
    {
        m_LogBox.AddString("Can't open the file");//Error
        return EXIT_FAILURE;
    }

    // Load RFF informations
    if (! LoadRffInformations ())
    {
        fclose (RffFile);
        return EXIT_FAILURE;
    }
		// If we want to extract all files
        if (ExtractAllFiles)
            for (int Ind = 0; (unsigned int)Ind < NbFiles; Ind++)
                ExtractFile (FileInfos[Ind].Name);

        // Else, we just extract the requested files
        if (ExtractFiles) //singular
		for (int i = m_RffDataBox.GetCount(); i > -1 ; i--)
		{    
			if (m_RffDataBox.GetSel(i) != 0 )
			{ 
			CString Timmy;
			m_RffDataBox.GetText(i,Timmy);
			ExtractFile (Timmy);
			UpdateData(FALSE);
			}	
	
		}		
	ExtractAllFiles = false;// for my "flag" dealie
	ExtractFiles = false;	// for my "flag" dealie
	free (FileInfos);
    fclose (RffFile);
    return EXIT_SUCCESS;
}

void CWinBarfDlg::OnSelchangeRfflist() 
{
	UpdateData(TRUE); // so the selected item is actually updated!	
}

void CWinBarfDlg::OnClearlog() 
{
	m_LogBox.ResetContent();
	UpdateData(FALSE);
}

void CWinBarfDlg::OnClearlist() 
{
	m_RffDataBox.ResetContent();
	UpdateData(FALSE);
}

void CWinBarfDlg::OnIdsOpenfile() 
{
	ExtractAllFiles = false;
	ExtractFiles = false;
	CFileDialog m_ldFile(TRUE); // create instance of file dialog window 
// a lotta code for a little tweak. shows JUST rff files, or all files. 
m_ldFile.m_ofn.lpstrFilter=TEXT("Blood Resource Files (*.RFF)\0*.RFF\0All Files (*.*)\0*.*\0"); 
	

if (m_ldFile.DoModal() == IDOK)	// this is what makes the popup happen!
{   

	// and we get that file name...	
	RffFileName = m_ldFile.GetFileName();		
	//now we clean out the box in case it had stuff in it. 
	m_RffDataBox.ResetContent();
	// update the log...
	m_LogBox.AddString(RffFileName + " was selected"); 
	
} // end if    
	if (!RffFileName.IsEmpty()) // this caused a crash on exit bug???
	oldmain(RffFileName.GetBuffer(4));

	// update the window with the data
	UpdateData(FALSE);		
	
}

void CWinBarfDlg::OnHelpAboutwinbarf() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
	
}

void CWinBarfDlg::OnFileClearlogbox() 
{
	m_LogBox.ResetContent();
	UpdateData(FALSE);	
}

void CWinBarfDlg::OnFileClearrffdatabox() 
{
	m_RffDataBox.ResetContent();
	UpdateData(FALSE);	
}

void CWinBarfDlg::OnFileExtractfiles() 
{
	if (RffFileName.IsEmpty())
		return;
	ExtractFiles = true;
	oldmain(RffFileName.GetBuffer(5)); 
}

void CWinBarfDlg::OnFileExtractall() 
{
	if (RffFileName.IsEmpty())
		return;
	else
	ExtractAllFiles = true;
	m_LogBox.AddString ("Extracting Files...");
	oldmain(RffFileName.GetBuffer(5));
}

void CWinBarfDlg::OnMiscClearrffboxselections() 
{
	// to clear out what was selected
	for (int i = m_RffDataBox.GetCount(); i > -1 ; i--)
	m_RffDataBox.SetSel(i, FALSE);
}

